/// <reference types="node" />
import { GraphQLSchema } from 'graphql';
import { HttpRequestHandler, PostGraphileOptions } from '../../interfaces';
import { Pool } from 'pg';
import { EventEmitter } from 'events';
export interface CreateRequestHandlerOptions extends PostGraphileOptions {
    getGqlSchema: () => Promise<GraphQLSchema>;
    pgPool: Pool;
    _emitter: EventEmitter;
}
export declare const graphiqlDirectory: string;
/**
 * Creates a GraphQL request handler that can support many different `http` frameworks, including:
 *
 * - Native Node.js `http`.
 * - `connect`.
 * - `express`.
 * - `koa` (2.0).
 */
export default function createPostGraphileHttpRequestHandler(options: CreateRequestHandlerOptions): HttpRequestHandler;
